Brain Teaser计算类 - 双败淘汰制

问题

在 2 n 2^n 2n个人(n>=1)参加的双败淘汰赛中,胜者组每一轮有一半的人胜出而继续留在胜者组。所以第n轮之后,胜者组第一次出现只剩1人的情况,此人的战绩是n胜0败。那么此时的败者组有多少人呢?

解答

首先,不难发现在第1轮到第n-1轮进入败者组的人数都为偶数,所以在第2轮到第n轮,败者组中没有发生轮空现象。因此,在第n轮后留在败者组的全体人员都进行了n场比赛,且他们的战绩均为n-1胜1败。

我们不妨改记胜者组、败者组为"0败组","1败组"。我们扩展定义"2败组"、......、"n败组",并假设从"i败组"失败的人会进入"i+1败组"进入下一轮比赛。由归纳法不难得到,第n轮后"i败组"所剩的人数是 C ( n , i ) C(n, i) C(n,i). 因此第n轮后的败者组有 C ( n , 1 ) = n C(n, 1)=n C(n,1)=n人,已被淘汰的人数为 ∑ i = 2 n C ( n , i ) = 2 n − 1 − n \sum_{i=2}^{n}{C(n, i)}=2^n-1-n ∑i=2nC(n,i)=2n−1−n人。

计算模拟代码如下:

python 复制代码
def double_fail(n):
    wins, loses = 2 ** n, 0
    while wins % 2 == 0 and loses % 2 == 0:
        print(wins, loses)
        wins >>= 1
        loses >>= 1
        loses += wins
    print(wins, loses)

执行结果:

bash 复制代码
>>> double_fail(3)
8 0
4 4
2 4
1 3
>>> double_fail(4)
16 0
8 8
4 8
2 6
1 4
>>> double_fail(5)
32 0
16 16
8 16
4 12
2 8
1 5
相关推荐
碧海银沙音频科技研究院11 分钟前
基于炬芯平台ATS308X多模型兼容语音识别算法
人工智能·算法·语音识别
爱读书的小胖28 分钟前
LeetCode 274 H 指数 C 语言解题分析
c语言·算法·leetcode·1024程序员节
basketball6161 小时前
动态规划第一章:引论
算法·动态规划·1024程序员节
星夜离尘561 小时前
MATLAB 因果采样保持:用历史匹配和数据年龄防止未来信息泄漏
数据结构·算法·matlab
思麟呀2 小时前
BTree的原理与 C++ 完整实现
c语言·数据结构·c++·算法·1024程序员节
Tsuki_tl2 小时前
【优选算法 — 双指针】经典例题题解+算法总结
算法·蓝桥杯·力扣·刷题·双指针·1024程序员节·优选算法
拓恒技术3 小时前
内河航道无人机智能巡检系统与算法应用
人工智能·深度学习·算法·无人机·智慧城市
如何原谅奋力过但无声3 小时前
【LeetCode hot100】代码随想录未cover部分
数据结构·算法·leetcode
INGNIGHT3 小时前
377.组合总和 Ⅳ(背包)
c++·算法·1024程序员节
拓恒技术4 小时前
城市管理中的无人机AI识别算法:架构、场景与落地
人工智能·算法·视觉检测·无人机·1024程序员节